// {{{RME classifier 'Logical View::InterfacesHw::CommExec_SenProx'

#ifndef CommExec_SenProx_H
#define CommExec_SenProx_H

#ifdef PRAGMA
#pragma interface "CommExec_SenProx.h"
#endif

#include <RTSystem/VerificarObstaculo.h>

struct CommExec_SenProx
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_StatusSensProx = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_CommExec_SenProx = rti_StatusSensProx };

	public:
		inline RTInSignal StatusSensProx( void );
		inline RTOutSignal PedidoStatus( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_PedidoStatus = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_CommExec_SenProx = rti_PedidoStatus };

	public:
		inline RTInSignal PedidoStatus( void );
		inline RTOutSignal StatusSensProx( const bool & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline CommExec_SenProx::Base::Base( void )
	: RTRootProtocol()
{
}

inline CommExec_SenProx::Base::~Base( void )
{
}

inline RTInSignal CommExec_SenProx::Base::StatusSensProx( void )
{
	return RTInSignal( this, rti_StatusSensProx );
}

inline RTOutSignal CommExec_SenProx::Base::PedidoStatus( void )
{
	return RTOutSignal( this, Conjugate::rti_PedidoStatus, (const void *)0, &RTType_void );
}

inline CommExec_SenProx::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline CommExec_SenProx::Conjugate::~Conjugate( void )
{
}

inline RTInSignal CommExec_SenProx::Conjugate::PedidoStatus( void )
{
	return RTInSignal( this, rti_PedidoStatus );
}

inline RTOutSignal CommExec_SenProx::Conjugate::StatusSensProx( const bool & data )
{
	return RTOutSignal( this, Base::rti_StatusSensProx, &data, &RTType_bool );
}

#endif /* CommExec_SenProx_H */

// }}}RME
