// {{{RME classifier 'Logical View::InterfacesHw::CommHwSensorProximidade'

#ifndef CommHwSensorProximidade_H
#define CommHwSensorProximidade_H

#ifdef PRAGMA
#pragma interface "CommHwSensorProximidade.h"
#endif

#include <RTSystem/VerificarObstaculo.h>

struct CommHwSensorProximidade
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_LeituraSensor = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_CommHwSensorProximidade = rti_LeituraSensor };

	public:
		inline RTInSignal LeituraSensor( void );
		inline RTOutSignal PedidoLeitura( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_PedidoLeitura = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_CommHwSensorProximidade = rti_PedidoLeitura };

	public:
		inline RTInSignal PedidoLeitura( void );
		inline RTOutSignal LeituraSensor( const bool & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline CommHwSensorProximidade::Base::Base( void )
	: RTRootProtocol()
{
}

inline CommHwSensorProximidade::Base::~Base( void )
{
}

inline RTInSignal CommHwSensorProximidade::Base::LeituraSensor( void )
{
	return RTInSignal( this, rti_LeituraSensor );
}

inline RTOutSignal CommHwSensorProximidade::Base::PedidoLeitura( void )
{
	return RTOutSignal( this, Conjugate::rti_PedidoLeitura, (const void *)0, &RTType_void );
}

inline CommHwSensorProximidade::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline CommHwSensorProximidade::Conjugate::~Conjugate( void )
{
}

inline RTInSignal CommHwSensorProximidade::Conjugate::PedidoLeitura( void )
{
	return RTInSignal( this, rti_PedidoLeitura );
}

inline RTOutSignal CommHwSensorProximidade::Conjugate::LeituraSensor( const bool & data )
{
	return RTOutSignal( this, Base::rti_LeituraSensor, &data, &RTType_bool );
}

#endif /* CommHwSensorProximidade_H */

// }}}RME
