// {{{RME classifier 'Logical View::XCapsulas::VerificarObstaculo'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VerificarObstaculo.h"
#endif

#include <RTSystem/VerificarObstaculo.h>
#include <VerificarObstaculo.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"PortSensProx"
	  , &CommHwSensorProximidade::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"PortExec"
	  , &CommExec_SenProx::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VerificarObstaculo_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VerificarObstaculo_Actor( _rts, _ref );
}

const RTActorClass VerificarObstaculo =
{
	(const RTActorClass *)0
  , "VerificarObstaculo"
  , (RTVersionId)0
  , 2
  , rtg_relays
  , new_VerificarObstaculo_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Desobstruido"
  , "Obstruido"
};

#define SUPER RTActor

VerificarObstaculo_Actor::VerificarObstaculo_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VerificarObstaculo_Actor::~VerificarObstaculo_Actor( void )
{
}

// {{{RME operation 'LerSensor()'
bool VerificarObstaculo_Actor::LerSensor( void )
{
	// {{{USR
	return(1);
	// }}}USR
}
// }}}RME

// {{{RME operation 'InformarStatus()'
bool VerificarObstaculo_Actor::InformarStatus( void )
{
	// {{{USR
	return(1);
	// }}}USR
}
// }}}RME

// {{{RME operation 'Inicializar()'
void VerificarObstaculo_Actor::Inicializar( void )
{
	// {{{USR

	// }}}USR
}
// }}}RME

int VerificarObstaculo_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// PortSensProx
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &PortSensProx;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// PortExec
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &PortExec;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

INLINE_CHAINS void VerificarObstaculo_Actor::chain5_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

void VerificarObstaculo_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain5_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Desobstruido'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:Obstruido'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VerificarObstaculo_Actor::getActorData( void ) const
{
	return &VerificarObstaculo_Actor::rtg_class;
}

const RTActor_class VerificarObstaculo_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 3
  , VerificarObstaculo_Actor::rtg_parent_state
  , &VerificarObstaculo
  , 0
  , (const RTComponentDescriptor *)0
  , 3
  , VerificarObstaculo_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 1
  , VerificarObstaculo_Actor::rtg_VerificarObstaculo_fields
};

const RTStateId VerificarObstaculo_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
};

const RTPortDescriptor VerificarObstaculo_Actor::rtg_ports[] =
{
	{
		"PortSensProx"
	  , (const char *)0
	  , &CommHwSensorProximidade::Conjugate::rt_class
	  , RTOffsetOf( VerificarObstaculo_Actor, VerificarObstaculo_Actor::PortSensProx )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"PortTempo"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( VerificarObstaculo_Actor, VerificarObstaculo_Actor::PortTempo )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"PortExec"
	  , (const char *)0
	  , &CommExec_SenProx::Base::rt_class
	  , RTOffsetOf( VerificarObstaculo_Actor, VerificarObstaculo_Actor::PortExec )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor VerificarObstaculo_Actor::rtg_VerificarObstaculo_fields[] =
{
	// {{{RME classAttribute 'Obstruido'
	{
		"Obstruido"
	  , RTOffsetOf( VerificarObstaculo_Actor, Obstruido )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_bool
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
